/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

/* 
  modified function from navigator.js with one exception
  function getReferrer(doc) because that belong to contentAreaUtils.js.
  this was added for Phoenix support: addPrefListener(observer)
*/

////////////////////////////////////////////////////////////////////////// 
function OpenBookmarkURL(node, datasource, event)
{
  if (node.nodeName == "menu")
    return;

  if (event && (node.id == "bookmarks_groupmark" || node.id == "PT_bookmarks_groupmark" || node.id == "bookmarks_button_groupmark"))
    return;

  var prefValue = readMyPref("multizilla.bookmark.groups", "int", 0);
  // XXX: new code for bug 3319
  if (prefValue & 1 && node.parentNode.parentNode.getAttribute("group") && !node.hasAttribute("id"))
    node = node.parentNode.parentNode;
  if (!node.hasChildNodes() && node.getAttribute("group") && node.hasAttribute("id")) {
    var tabCount = gBrowser.mPanelContainer.childNodes.length-1;
    var newTabs = readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
    var closeRemaining = readMyPref("multizilla.bookmark.close-remaining", "bool", false);
    // open dialog for settings
    if (newTabs == 2) {
      window.openDialog("chrome://multiviews/content/multiviewsAskSettings.xul", "_blank", "chrome,modal,centerscreen", getBrowser(), closeRemaining);
      newTabs = gBrowser.mNewTabs;
      closeRemaining = gBrowser.mRemoveRemaining;
      if (gBrowser.mNewTabs == -1)
        return;
    }
    else newTabs = (newTabs == 1) ? true : false;
    var startTab = newTabs ? (tabCount+1) : 0;
    OpenBookmarkFolder(node, datasource, (tabCount+1), newTabs, false, false);
    gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[startTab];

    if (closeRemaining) {
      if (newTabs) {
        /* startTab = gBrowser.mTabList[startTab].ordinal-1;
        for (i = startTab; i >= 0; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]); */
      }
      else {
        for (var i = tabCount; i >= tabIndex; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]);
      }
    }
    return;
  }
  var allowMiddleClicks = readMyPref("multizilla.bookmark.menuitem.allow-middleclick", "bool", false);

  if (node.getAttribute("container") == "true" || (node.nodeName == "menuitem" && event && event.button == 1 && !allowMiddleClicks) )
    return;
  var url = node.getAttribute("id");

  if (!url)
    return;

  try {
    if (datasource) {
      var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
      var src = rdf.GetResource(url, true);
      var prop = rdf.GetResource("http://home.netscape.com/NC-rdf#URL", true);
      var target = datasource.GetTarget(src, prop, true);
      if (target) {
        target = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
        if (target)
          url = target;
      }
    }
  } catch (ex) {
    return;
  }
  if (url.substring(0, 3) == "NC:")
    return;
  if (_content) {
    if (preventDupeTab(url))
      return;
    var backupNode = node; // save original

    while (node.nodeName != "toolbarbutton" && node.nodeName != "menubar")
      node = node.parentNode;
    var shiftKey = false;
    var ctrlKey = false;
    var button = false;
    if (event) {
      shiftKey = event.shiftKey;
      ctrlKey = event.ctrlKey;
      button = event.button;
    }
    if ((node.nodeName == "menubar" && pref && pref.getBoolPref("multizilla.newtabfor.bookmarks") && !shiftKey) ||
        (node.nodeName == "toolbarbutton" /* XXX: see bug 2675 && node.id != "bookmarks-button" */ && 
        pref && pref.getBoolPref("multizilla.newtabfor.personal-toolbar") && !shiftKey) || 
        ctrlKey || button == 1) {
      if (url.substring(0,10) == "javascript") {
	    if (url.indexOf("getSelection(") == -1)
          loadURI(url, null);
        else
          setTimeout(function() { loadURI(url, null) }, 0, gBrowser.selectedTab = getBrowser().addTab());
      }
      else {
        var tab = null;
        var browser = checkForBlankTab();

        if (browser) {
          browser.loadURI(getShortcutOrURI(url, null));
          tab = gBrowser.getTabForBrowser(browser);
        }
        else
          tab = gBrowser.addTab(getShortcutOrURI(url));

        if (!readMyPref("multizilla.bookmark.loadInBackground", "bool", false))
          gBrowser.selectedTab = tab;
      }
    }
    else {
      loadURI(url, null);
      _content.focus();
    }
    // Do we need to close menupopups?
    if (allowMiddleClicks && readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true)) {
      node = backupNode;
      while (node.nodeName != "toolbarbutton" && node.nodeName != "menubar") {
        node = node.parentNode;
        if (node.nodeName == "menupopup")
          node.hidePopup();
      }
      // We need to 'Close" the Bookmarks button on the menubar
      if (node.nodeName == "menubar") {
        var menu = document.getElementById("BookmarksMenu");
        menu.setAttribute("_moz-menuactive", false);
      }
    }
  }
  else
    openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url);
}
//////////////////////////////////////////////////////////////////////////
function BrowserLoadURL(aTriggeringEvent)
{
  var url = gURLBar.value;
  if (url.match(/^view-source:/)) {
    BrowserViewSourceOfURL(url.replace(/^view-source:/, ""), null, null);
  } else {
    // Check the pressed modifiers: (also see bug 97123)
    // Modifier Mac | Modifier PC | Action
    // -------------+-------------+-----------
    // Command      | Control     | New Window/Tab
    // Shift+Cmd    | Shift+Ctrl  | New Window/Tab behind current one
    // Option       | Shift       | Save URL (show Filepicker)

    // If false, the save modifier is Alt, which is Option on Mac.
    var modifierIsShift = true;
    try {
      modifierIsShift = pref.getBoolPref("ui.key.saveLink.shift");
    }
    catch (ex) {}

    var shiftPressed = false;
    var saveModifier = false; // if the save modifier was pressed
    if (aTriggeringEvent && 'shiftKey' in aTriggeringEvent &&
        'altKey' in aTriggeringEvent) {
      saveModifier = modifierIsShift ? aTriggeringEvent.shiftKey
                     : aTriggeringEvent.altKey;
      shiftPressed = aTriggeringEvent.shiftKey;
    }

    var browser = getBrowser();
    url = getShortcutOrURI(url);
    var newTab = readMyPref("multizilla.newtabfor.locationbar", "bool", false);
    // Accept both Control and Meta (=Command) as New-Window-Modifiers
    if ((aTriggeringEvent &&
        (('ctrlKey' in aTriggeringEvent && aTriggeringEvent.ctrlKey) ||
         ('metaKey' in aTriggeringEvent && aTriggeringEvent.metaKey))) || newTab) {
      // Check if user requests Tabs instead of windows
      var openTab = false;
      try {
        openTab = pref.getBoolPref("browser.tabs.opentabfor.urlbar");
      }
      catch (ex) {}

      if (openTab || newTab) {
        // Open link in new tab
        var t = browser.addTab(url);

        // Focus new tab unless shift is pressed
        if (!shiftPressed) {
          browser.userTypedValue = null;
          browser.selectedTab = t;
        }
      } else {
        // Open a new window with the URL
        var newWin = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url);
        // Reset url in the urlbar, copied from handleURLBarRevert()
        var oldURL = browser.currentURI.spec;
        if (oldURL != "about:blank") {
          gURLBar.value = oldURL;
          SetPageProxyState("valid", null);
        } else
          gURLBar.value = "";

        browser.userTypedValue = null;

        // Focus old window if shift was pressed, as there's no
        // way to open a new window in the background
        // XXX this doesn't seem to work
        if (shiftPressed) {
          //newWin.blur();
          content.focus();
        }
      }
    } else if (saveModifier) {
      try {
        // Firstly, fixup the url so that (e.g.) "www.foo.com" works
        const nsIURIFixup = Components.interfaces.nsIURIFixup;
        if (!gURIFixup)
          gURIFixup = Components.classes["@mozilla.org/docshell/urifixup;1"]
                                .getService(nsIURIFixup);
        url = gURIFixup.createFixupURI(url, nsIURIFixup.FIXUP_FLAGS_MAKE_ALTERNATE_URI).spec;
        // Open filepicker to save the url
        saveURL(url, "");
      }
      catch(ex) {
        // XXX Do nothing for now.
        // Do we want to put up an alert in the future?  Mmm, l10n...
      }
    } else {
      // No modifier was pressed, load the URL normally and
      // focus the content area
      loadURI(url);
      content.focus();
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function LoadBookmarksCallback() // for mozilla v1.4+
{
  // loads the services
  initServices();
  initBMService();
  // var hasRead = BMSVC.readBookmarks();
  BMSVC.readBookmarks();
  var bt = document.getElementById("bookmarks-ptf");
  if (bt) {
    // if (hasRead)
      // bt.builder.rebuild();
    bt.database.AddObserver(BookmarksToolbarRDFObserver);
  }
  window.addEventListener("resize", BookmarksToolbar.resizeFunc, false);
  controllers.appendController(BookmarksMenuController);
  // tickle personal toolbar to load personal toolbar items (fix for bug 4327)
  var personalToolbar = document.getElementById("bookmarks-ptf"); // NC:PersonalToolbarFolder");
  personalToolbar.builder.rebuild();
  // Check if we have to load a saved tab session
  var chromeHidden = document.documentElement.hasAttribute("chromehidden");
  if (pref && pref.getIntPref("browser.startup.page") == 3 && !chromeHidden)
    OpenBookmarkGroup(null, document.getElementById('BookmarksMenu').database);
  var tabbrowser = getBrowser();
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroup(element, datasource, id)
{
  if (!datasource)
    return;
  if (element)
    id = element.getAttribute("id");
  else {
    id = readMyPref("multizilla.tabs.groupmark", "string", null);
    if (!id)
      return;
  }
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
  var resource = rdf.GetResource(id, true);
  OpenBookmarkGroupFromResource(resource, datasource, rdf);
}
//////////////////////////////////////////////////////////////////////////
// This is added to maintain backward compatibility. We should remove it 
// when people start using a more recent mozilla build.
//////////////////////////////////////////////////////////////////////////
function updateGroupmarkMenuitem(id)
{
  const disabled = gBrowser.browsers.length == 1;
  document.getElementById(id).setAttribute("disabled", disabled);
}
//////////////////////////////////////////////////////////////////////////
function BrowserViewSourceOfURL(url, charset, pageCookie)
{
  var loadFromURL = true;
  if (readMyPref("multizilla.newtabfor.view-source", "bool", false)) {
    try {
      if (typeof(pageCookie) == "object") {
        if (url != "about:blank")
          gBrowser.selectedTab = gBrowser.addTab('about:blank');
        var PageLoader = getBrowser().webNavigation.QueryInterface(Components.interfaces.nsIWebPageDescriptor);
        PageLoader.LoadPage(pageCookie, Components.interfaces.nsIWebPageDescriptor.DISPLAY_AS_SOURCE);
        loadFromURL = false;
      }
    } catch(ex) { 
	}
    if (loadFromURL)
      gBrowser.addTab('view-source:'+url);
  }
  else {
    openDialog("chrome://navigator/content/viewSource.xul", "_blank",
               "scrollbars,resizable,chrome,dialog=no", url, charset, pageCookie);
  }
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroupFromResource(resource, datasource, rdf)
{
  var urlResource = rdf.GetResource("http://home.netscape.com/NC-rdf#URL");
  var rdfContainer = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
  rdfContainer.Init(datasource, resource);
  var containerChildren = rdfContainer.GetElements();
  var index = 0;

  for (; containerChildren.hasMoreElements(); index++) {
    var res = containerChildren.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var target = datasource.GetTarget(res, urlResource, true);
    if (target) {
      var uri = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      if (!preventDupeTab(uri)) {
        if (index == 0)
          gBrowser.loadURI(uri);
        else gBrowser.addTab(uri);
      }
    }
  }  
  if (index == 0)
    return; // If the bookmark group was completely invalid, just bail.

  var tabCount = gBrowser.mPanelContainer.childNodes.length-1;
  var inBackground = pref.getBoolPref("browser.tabs.loadInBackground") ? 0 : tabCount;
  var tabs = gBrowser.mTabContainer.childNodes;
  gBrowser.selectedTab = tabs[inBackground];
}
//////////////////////////////////////////////////////////////////////////
// This modified version can handle multiple pref settings
//////////////////////////////////////////////////////////////////////////
function addPrefListener(observer)
{
  var domains = ("domains" in observer) ? observer.domains : [observer.domain];
  try {
    var pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    for (var i = 0; i < domains.length; i++)
      pbi.addObserver(domains[i], observer, false);
  } catch(ex) {
    dump("Failed to observe prefs: " + ex + "\n");
  }
}
//////////////////////////////////////////////////////////////////////////
// Fill in tooltips for personal toolbar (older versions of navigator.js)
//////////////////////////////////////////////////////////////////////////
function FillInPTTooltip(tipElement) // for mozilla v1.4
{
  var title = tipElement.label;
  var url = tipElement.statusText;

  if (!title && !url) {
    // bail out early if there is nothing to show
    return false;
  }
  var tooltipTitle = document.getElementById("ptTitleText");
  var tooltipUrl = document.getElementById("ptUrlText"); 

  if (title && title != url) {
    tooltipTitle.removeAttribute("hidden");
    tooltipTitle.setAttribute("value", title);
  } else  {
    tooltipTitle.setAttribute("hidden", "true");
  }
  if (url) {
    tooltipUrl.removeAttribute("hidden");
    tooltipUrl.setAttribute("value", url);
  } else {
    tooltipUrl.setAttribute("hidden", "true");
  }
  return true; // show tooltip
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'updateOverflowMenu' in bookmarksMenu.js
//////////////////////////////////////////////////////////////////////////
BookmarksToolbar.updateOverflowMenu = function(aMenuPopup)
{
   var hbox = document.getElementById("bookmarks-ptf");
   // There will be two menu items missing from the overflow menu, without this modification
   // We replace mozilla's template, this is why we have two extra childnodes,
   // childNodes[0] = tooltip and childNodes[1] = our modified template
   for (var i = 2; i < hbox.childNodes.length; i++) {
     var button = hbox.childNodes[i];
     var menu = aMenuPopup.childNodes[(i-2)];
     if (menu.hidden == button.collapsed)
       menu.hidden = !menu.hidden;
   }
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'StatusbarViewPopupManager' in navigator.js
// This opens the more powerful permission manager of MultiZilla.
//////////////////////////////////////////////////////////////////////////
function StatusbarViewPopupManager()
{
  var hostPort = "";
  try {
    hostPort = getBrowser().selectedBrowser.currentURI.hostPort;
  }
  catch(ex) { }
  window.openDialog("chrome://multiviews/content/multiviewsPermissionManager.xul", "",
                    "chrome,resizable=yes", "popupManager", hostPort);
}
//////////////////////////////////////////////////////////////////////////
// We need to get notified of blocked popup windows. We replace the 
// original eventlistener for 'DOMPopupBlocked' with our (this) event 
// listener and call 'onPopupBlocked' (original function) when we're done.
//////////////////////////////////////////////////////////////////////////
function mzOnPopupBlocked(aEvent)
{
  var popupWindowURI = aEvent.popupWindowURI;
  var requestingWindowURI = aEvent.requestingWindowURI;
  popupWindowURI = popupWindowURI ? popupWindowURI.spec : null;
  // requestingWindowURI = requestingWindowURI ? requestingWindowURI.spec : null;
  // alert("popupWindowURI: "+popupWindowURI+"\nrequestingWindowURI: "+requestingWindowURI);

  // var popupWindowURI = aEvent.popupWindowURI;
  // Keep URI so that we can open it on request!
  if (popupWindowURI) { // Well, if we have one, because that's not always the case!
    var browser = getBrowserForDocument(aEvent.target);
    addBlockedWindowToMenu(browser, popupWindowURI);
  }
  onPopupBlocked(aEvent); // we're done, call mozilla's listener
}
//////////////////////////////////////////////////////////////////////////
// This will add the URL of the blocked popup window to the list and also 
// enables the icon/menu popup on the status bar.
//////////////////////////////////////////////////////////////////////////
function addBlockedWindowToMenu(aBrowser, aBlockedURI)
{
  // Add the URL to the list of blocked windows. This allows the user to open it!
  aBrowser.mBlockedWindows.push(aBlockedURI);
  /***
  * We keep track of the last 15 blocked popup windows only!
  * I'm still not sure *if* we should check for duplicates.
  */
  if (aBrowser.mBlockedWindows.length > 15)
    aBrowser.mBlockedWindows.splice(0, 1);
  // Do we need to enable the blocked window menu icon?
  if (aBrowser == gBrowser.mCurrentBrowser) {
    var button = document.getElementById("blocked-window-button");
    button.setAttribute("blocked", "true");
  }
}
//////////////////////////////////////////////////////////////////////////
// This will add menu items to the blocked window menu on the status bar
//////////////////////////////////////////////////////////////////////////
function buildBlockedPopupWindowMenu(aParent)
{
  deleteHistoryItems(aParent); // depends on sessionHistoryUI.js
  var tabbrowser = getBrowser();
  var counter = tabbrowser.mCurrentBrowser.mBlockedWindows.length;

  for (var i = 0; i < counter; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", tabbrowser.mCurrentBrowser.mBlockedWindows[i]);
    menuitem.setAttribute("index", i); // make deleteHistoryItems() work
    aParent.appendChild(menuitem);
  }
}
//////////////////////////////////////////////////////////////////////////
// This allows you to open the blocked window in a new Tab or new Window
//////////////////////////////////////////////////////////////////////////
function openBlockedWindow(aEvent)
{
  var URL = aEvent.originalTarget.getAttribute("label");
  if (URL == "about:blank" || URL == "")
    return;
  if (aEvent.ctrlKey)
    window.open(URL);
  else {
    var tabbrowser = getBrowser();
    tabbrowser.selectedTab = tabbrowser.addTab(URL);
  }
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'gPopupPrefListener' in navigator.js
//////////////////////////////////////////////////////////////////////////
const mzPopupPrefListener =
{
  domain: "dom.disable_open_during_load",
  observe: function(subject, topic, prefName)
  {        
    if (topic != "nsPref:changed")
      return;

    var whitelist = pref.getBoolPref(prefName);

    if (whitelist && pref.getBoolPref("privacy.popups.first_popup"))
      pref.setBoolPref("privacy.popups.first_popup", false);

    var count = 0;
    var hosts = [];
    var permissionManager = Components.classes["@mozilla.org/permissionmanager;1"]
                                      .getService(Components.interfaces.nsIPermissionManager);
    var enumerator = permissionManager.enumerator;
    var capability = whitelist ? nsIPermissionManager.DENY_ACTION : nsIPermissionManager.ALLOW_ACTION;

    while (enumerator.hasMoreElements()) {
      var nextPermission = enumerator.getNext();
      nextPermission = nextPermission.QueryInterface(Components.interfaces.nsIPermission);
      if (nextPermission.type == "popup") {
        if (nextPermission.capability == capability)
          hosts[nextPermission.host] = nextPermission.host;
      }
    }
    var popupIcon = document.getElementById("popupIcon");
    var browsers = getBrowser().browsers;
    
    for (var i = 0; i < browsers.length; i++) {
      if (!whitelist && browsers[i].popupDomain in hosts)
        break;
      browsers[i].popupDomain = null;
      popupIcon.hidden = true;
    }
  }
};